<?php

class ControllerExtensionModuleMessaggio extends Controller
{
    protected $version = '1.0.0';
    protected $error = [];

    public function index()
    {
        $this->load->language('extension/module/messaggio');

        $this->document->setTitle(strip_tags($this->language->get('heading_title')));

        $this->load->model('extension/module/messaggio');

        $this->getList();
    }

    public function settings()
    {
        $this->load->language('extension/module/messaggio');

        $this->document->setTitle(strip_tags($this->language->get('heading_title')));

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {

            $this->load->model('setting/setting');

            $this->model_setting_setting->editSetting('messaggio_settings', $this->request->post);

            $this->model_setting_setting->editSetting('module', ['module_messaggio_status' => !empty($this->request->post['messaggio_settings_status']) ? '1' : '0']);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'], true));
        }

        $this->getList();
    }

    public function save_template()
    {
        $this->load->language('extension/module/messaggio');

        $this->document->setTitle(strip_tags($this->language->get('heading_title')));

        $this->load->model('extension/module/messaggio');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {

            $this->model_extension_module_messaggio->saveTemplates($this->request->get['template_id'], $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=templates', true));
        }

        $this->getList();
    }

    public function delete_template()
    {
        $this->load->language('extension/module/messaggio');

        $this->document->setTitle(strip_tags($this->language->get('heading_title')));

        $this->load->model('extension/module/messaggio');

        if (($this->request->server['REQUEST_METHOD'] == 'GET') && $this->validateForm()) {

            $this->model_extension_module_messaggio->deleteTemplates($this->request->get['template_id']);

            $this->session->data['success'] = $this->language->get('text_success_delete');

            $this->response->redirect($this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=templates', true));
        }

        $this->getList();
    }

    public function active_template()
    {
        $this->load->language('extension/module/messaggio');

        $this->document->setTitle(strip_tags($this->language->get('heading_title')));

        $this->load->model('extension/module/messaggio');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {

            $this->model_extension_module_messaggio->activeTemplates($this->request->get['template_id'], $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=templates', true));
        }

        $this->getList();
    }

    protected function getList()
    {
        $tab = isset($this->request->get['tab']) ? $this->request->get['tab'] : 'settings';

        if (isset($this->request->get['sort'])) {
            $sort = $this->request->get['sort'];
        } else {
            $sort = 'name';
        }

        if (isset($this->request->get['order'])) {
            $order = $this->request->get['order'];
        } else {
            $order = 'ASC';
        }

        if (isset($this->request->get['page'])) {
            $page = $this->request->get['page'];
        } else {
            $page = 1;
        }

        $url = '';

        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }

        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }

        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data = [
            'sort'     => $sort,
            'order'    => $order,
            'page'     => $page,
            'start'    => $this->config->get('config_limit_admin') * ($page - 1),
            'limit'    => $this->config->get('config_limit_admin'),
            'page_tab' => $tab,
        ];

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->session->data['success'])) {
            $data['success'] = $this->session->data['success'];

            unset($this->session->data['success']);
        } else {
            $data['success'] = '';
        }

        $data['breadcrumbs'] = [];

        $data['breadcrumbs'][] = [
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], true),
        ];

        $data['breadcrumbs'][] = [
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true),
        ];

        $data['breadcrumbs'][] = [
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'], true),
        ];

        $data['heading_title'] = $this->language->get('heading_title');

        $data['tab_settings'] = $this->language->get('tab_settings');
        $data['tab_templates'] = $this->language->get('tab_templates');

        $data['history_action'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=history', true);
        $data['settings_action'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=settings', true);
        $data['settings_action_save'] = $this->url->link('extension/module/messaggio/settings', 'user_token=' . $this->session->data['user_token'], true);
        $data['templates_action'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=templates', true);
        $data['templates_action_edit'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=edit-templates', true);
        $data['templates_action_edit_save'] = $this->url->link('extension/module/messaggio/save_template', 'user_token=' . $this->session->data['user_token'] . '&template_id=' . (!empty($this->request->get['template_id']) ? $this->request->get['template_id'] : '0'), true);
        $data['cancel'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . $url, true);

        $data['entry_sending_channel'] = $this->language->get('entry_sending_channel');
        $data['text_senderid'] = $this->language->get('text_senderid');
        $data['entry_messaggio_login'] = $this->language->get('entry_messaggio_login');
        $data['text_messaggio_login'] = $this->language->get('text_messaggio_login');
        $data['text_create_template'] = $this->language->get('text_create_template');
        $data['text_event'] = $this->language->get('text_event');
        $data['text_category'] = $this->language->get('text_category');
        $data['text_recipient'] = $this->language->get('text_recipient');
        $data['text_status'] = $this->language->get('text_status');
        $data['text_no_results'] = $this->language->get('text_no_results');
        $data['column_active'] = $this->language->get('column_active');
        $data['column_status'] = $this->language->get('column_status');
        $data['column_action'] = $this->language->get('column_action');
        $data['column_date'] = $this->language->get('column_date');
        $data['column_channel'] = $this->language->get('column_channel');
        $data['column_phone'] = $this->language->get('column_phone');
        $data['text_edit_template'] = $this->language->get('text_edit_template');
        $data['text_delete_template'] = $this->language->get('text_delete_template');
        $data['column_language'] = $this->language->get('column_language');
        $data['button_cancel'] = $this->language->get('button_cancel');
        $data['button_save'] = $this->language->get('button_save');

        $data['user_token'] = $this->session->data['user_token'];

        $data['messaggio_settings_messaggio_login'] = $this->config->get('messaggio_settings_messaggio_login');
        $data['messaggio_settings_senderid'] = $this->config->get('messaggio_settings_senderid');
        $data['messaggio_settings_channel'] = $this->config->get('messaggio_settings_channel');
        $data['messaggio_settings_status'] = $this->config->get('module_messaggio_status');

        $this->load->model('localisation/order_status');

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $this->load->model('localisation/return_status');

        $data['return_statuses'] = $this->model_localisation_return_status->getReturnStatuses();

        $this->load->model('localisation/language');

        $data['languages'] = $this->model_localisation_language->getLanguages();

        $data['categories'] = $this->model_extension_module_messaggio->getCategories();

        if (isset($this->request->post['store_id'])) {
            $data['store_id'] = $this->request->post['store_id'];
        } else {
            $data['store_id'] = '';
        }

        $this->load->model('setting/store');

        $data['stores'] = $this->model_setting_store->getStores();


        $data['this_template'] = [];

        if ($tab == 'templates' || $tab == 'edit-templates') {
            $templates = $this->model_extension_module_messaggio->getTemplates();

            foreach ($templates as $cat_id => $temp) {
                foreach ($temp as $id => $template) {
                    $templates[$cat_id][$id]['link'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&tab=edit-templates&template_id=' . $template['id'], true);
                    $templates[$cat_id][$id]['link_delete'] = $this->url->link('extension/module/messaggio/delete_template', 'user_token=' . $this->session->data['user_token'] . '&template_id=' . $template['id'], true);
                    $templates[$cat_id][$id]['link_active'] = $this->url->link('extension/module/messaggio/active_template', 'user_token=' . $this->session->data['user_token'] . '&template_id=' . $template['id'], true);

                    if (isset($this->request->get['template_id']) && $this->request->get['template_id'] == $template['id']) {
                        $data['this_template'] = $template;
                    }

                }
            }

            $data['templates'] = $templates;
        }

        $total = 0;
        $url = '';

        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }

        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }


        if ($tab == 'history') {
            $historys = $this->model_extension_module_messaggio->getHistory($data['limit'], $data['start']);
            if (!empty($historys) && is_array($historys))
                foreach ($historys as $key => $value) {
                    $historys[$key]['created_at'] = (new DateTime($value['created_at']))->format('d.m.Y H:i');
                    $badge_text = $value['type'] == 'danger' || $value['type'] == 'warning' ? $this->language->get('text_status_warning') : $this->language->get('text_status_success');
                    if (isset($value['response']['delivered']) && $value['response']['delivered']) {
                        $badge_text = $this->language->get('text_status_delivered');
                    }
                    $historys[$key]['badge_text'] = $badge_text;
                }
            $data['historys'] = $historys;
            $total = $this->model_extension_module_messaggio->getHistoryTotal();
        }

        $pagination = new Pagination();

        $pagination->total = $total;
        $pagination->page = $page;
        $pagination->limit = $this->config->get('config_limit_admin');
        $pagination->text = $this->language->get('text_pagination');
        $pagination->url = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}&tab=' . $tab, true);

        $data['pagination'] = $pagination->render();


        $data['results'] = sprintf($this->language->get('text_pagination'), ($total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($total - $this->config->get('config_limit_admin'))) ? $total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $total, ceil($total / $this->config->get('config_limit_admin')));


        $data['sort'] = $sort;
        $data['order'] = $order;

        if ($order == 'ASC') {
            $order = 'DESC';
        } else {
            $order = 'ASC';
        }

        $url = '';

        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data['sort_name'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&sort=name&order=' . $order . $url, true);
        $data['sort_type'] = $this->url->link('extension/module/messaggio', 'user_token=' . $this->session->data['user_token'] . '&sort=type&order=' . $order . $url, true);

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/module/messaggio_list', $data));
    }

    protected function validateForm()
    {
        if (!$this->user->hasPermission('modify', 'extension/module/messaggio')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        return !$this->error;
    }

    public function install()
    {
        if (!$this->user->hasPermission('modify', 'extension/extension/module')) {
            return;
        }
        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "messaggio_requests` (
		  `id` int UNSIGNED NOT NULL AUTO_INCREMENT,
		  `channel` varchar(255) NOT NULL,
		  `phone` varchar(255) NOT NULL,
		  `message` varchar(1000) NOT NULL,
		  `message_id` varchar(255) DEFAULT NULL,
		  `status` int(11) DEFAULT NULL,
		  `error` varchar(255) DEFAULT NULL,
		  `type` varchar(255) DEFAULT NULL,
		  `created_at` timestamp NULL DEFAULT NULL,
		  `updated_at` timestamp NULL DEFAULT NULL,
		  `store_id` int(11) NOT NULL,
		  PRIMARY KEY (`id`)
		) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;");

        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "messaggio_responses` (
		  `id` int UNSIGNED NOT NULL AUTO_INCREMENT,
		  `message_id` varchar(255) NOT NULL,
		  `channel` varchar(255) NOT NULL,
		  `external_id` varchar(255) DEFAULT NULL,
		  `status` int(11) DEFAULT NULL,
		  `type` varchar(255) DEFAULT NULL,
		  `created_at` timestamp NULL DEFAULT NULL,
		  `updated_at` timestamp NULL DEFAULT NULL,
		   PRIMARY KEY (`id`)
		) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;");

        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "messaggio_templates` (
		  `id` int UNSIGNED NOT NULL AUTO_INCREMENT,
		  `store_id` int(11) NOT NULL,
		  `group` varchar(191) NOT NULL,
		  `action` varchar(191) NOT NULL,
		  `number` varchar(191) NOT NULL,
		  `message` text NOT NULL,
		  `active` tinyint(1) NOT NULL,
		  `language` int(11) NOT NULL,
		   PRIMARY KEY (`id`)
		) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;");
//
//        $this->load->model('setting/store');
//        $stores = $this->model_setting_store->getStores();
//        $stores[] = ['store_id' => 0];


        $this->load->model('setting/event');

        $this->model_setting_event->deleteEvent('module_messaggio');

        $this->model_setting_event->addEvent('module_messaggio', 'catalog/model/checkout/order/addOrderHistory/after', 'extension/module/messaggio/eventChangeOrder');
        $this->model_setting_event->addEvent('module_messaggio', 'admin/model/sale/return/addReturnHistory/after', 'extension/module/messaggio/eventChangeReturn');
        $this->model_setting_event->addEvent('module_messaggio', 'admin/model/sale/return/addReturn/after', 'extension/module/messaggio/eventChangeReturn');
    }

    public function uninstall()
    {
        if (!$this->user->hasPermission('modify', 'extension/extension/module')) {
            return;
        }

        $this->load->model('setting/event');

        $this->model_setting_event->deleteEventByCode('module_messaggio');
    }

    public function eventChangeReturn($hook, $args, $output)
    {
        if ($this->config->get('messaggio_settings_status')) {
            $this->load->model('sale/return');
            $this->load->model('extension/module/messaggio');
            $this->load->model('sale/order');

            $return_id = !empty($this->request->get['return_id']) ? $this->request->get['return_id'] : (!empty($args[0]) && !is_array($args[0]) ? $args[0] : 0);
            $return_status_id = !empty($this->request->post['return_status_id']) ? $this->request->post['return_status_id'] : (!empty($args[1]) ? $args[1] : 0);
            $comment = !empty($this->request->post['comment']) ? $this->request->post['comment'] : (!empty($args[2]) ? $args[2] : '');
            $notify = !empty($this->request->post['notify']) ? $this->request->post['notify'] : (!empty($args[3]) ? $args[3] : '');

            if (!empty($return_id))
                $return_order_info = $this->model_sale_return->getReturn($return_id);
            else if (!empty($args[0]) && is_array($args[0]))
                $return_order_info = $args[0];

            if (!empty($return_order_info)) {

                $order_id = !empty($return_order_info['order_id']) ? $return_order_info['order_id'] : '';

                $order_info = $this->model_sale_order->getOrder($order_id);

                $store_id = 0;

                if (!empty($order_info)) {

                    $store_id = $order_info['store_id'];

                    $language_id = $order_info['language_id'];

                    $templates = $this->model_extension_module_messaggio->getTemplateByAction($store_id, 'return_status-' . $return_status_id, $language_id);

                } else {
                    $templates = $this->model_extension_module_messaggio->getTemplateByAction(false, 'return_status-' . $return_status_id, false);
                }


                if (!empty($templates)) {
                    foreach ($templates as $template) {
                        $phone = $template['number'];
                        $message = $template['message'];
                        $phone = $this->model_extension_module_messaggio->parseShortcodeOrder($phone, $order_info, $return_order_info);
                        $message = $this->model_extension_module_messaggio->parseShortcodeOrder($message, $order_info, $return_order_info);
                        if (!empty($phone) && !empty($message))
                            $this->model_extension_module_messaggio->send($phone, $message, $store_id);
                    }
                }

            }
        }
    }
}
