<?php

class ControllerExtensionModuleMessaggio extends Controller
{

    public function eventChangeOrder($hook, $input, $output)
    {
        if ($this->config->get('messaggio_settings_status')) {

            $this->load->model('extension/module/messaggio');
            $this->load->model('checkout/order');

            $order_id = !empty($this->request->get['order_id']) ? $this->request->get['order_id'] : (!empty($input[0]) ? $input[0] : '');
            $store_id = !empty($this->request->get['store_id']) ? $this->request->get['store_id'] : '';

            if ($order_id) {
                $order_info = $this->model_checkout_order->getOrder($order_id);

                if (!empty($order_info)) {

                    $status_id = $order_info['order_status_id'];

                    $language_id = $order_info['language_id'];

                    $templates = $this->model_extension_module_messaggio->getTemplateByAction($store_id, 'order_status-' . $status_id, $language_id);

                    if (!empty($templates)) {
                        // Order confirmation
                        foreach ($templates as $template) {
                            $phone = $template['number'];
                            $message = $template['message'];
                            $phone = $this->model_extension_module_messaggio->parseShortcodeOrder($phone, $order_info);
                            $message = $this->model_extension_module_messaggio->parseShortcodeOrder($message, $order_info);
                            if (!empty($phone) && !empty($message))
                                $this->model_extension_module_messaggio->send($phone, $message, $store_id);
                        }
                    }
                }
            }
        }

    }

    public function callback()
    {
        if (($this->request->server['REQUEST_METHOD'] == 'POST')) {
            $request = json_decode(file_get_contents('php://input'), true);

            if (!empty($request['message_id']) && !empty($request['channel'])) {
                $d = DateTime::createFromFormat('Y-m-d\TH-i-s\Z', !empty($request['timestamp']) ? $request['timestamp'] : '');
                $this->db->query("INSERT INTO " . DB_PREFIX . "messaggio_responses SET `message_id` = '" . $this->db->escape($request['message_id']) . "', `channel` = '" . $this->db->escape($request['channel']) . "', `external_id` = '" . $this->db->escape(!empty($request['external_id']) ? $request['external_id'] : null) . "', `status` = '" . $this->db->escape((int)(!empty($request['status']) ? $request['status'] : 0)) . "', `type` = '" . $this->db->escape(!empty($request['type']) ? $request['type'] : '') . "', `created_at` = '" . $this->db->escape($d ? $d->format('Y-m-d H:i:s') : date('Y-m-d H:i:s')) . "', `updated_at` = '" . $this->db->escape(date('Y-m-d H:i:s')) . "'");
            }
        }
        exit();
    }
}
